/* SYNTAX2.CPP -- demonstrate pointer declarations */
/* Jim Fawcett, CSE687                             */

#include <iostream.h>        /* note: no semicolon for preprocs  */

void main() {

  cout << "--- syntax2.cpp ---\n\n";

// pointer to primitive type

  double x = 1.5;
  double *ptr;        // ptr will point to a double value
  ptr = &x;           // ptr now points to x
  cout << "*ptr = " << *ptr << "\n";
		      // will print contents of ptr, e.g., value of x

// pointer to array

  double y[5] = { 5.0, 4.1, 3.2, 2.3, 1.4 };
		      // y is name of an array of five doubles
  cout << "y[0] = " << y[0] << ",  *(y + 2) = " << *(y + 2) << "\n";
		      // note that y acts like a pointer

  double *dptr = y;   // new pointer to the array
  cout << "dptr[0] = " << dptr[0] << ",  *(dptr + 2) = "
				  << *(dptr + 2) << "\n";

// pointers to structures

  struct first_str {         /* structure declaration            */
    int    x;                /* structure elements can't be      */
    double y;                /* initialized in declaration       */
  } a = { 1, 4.5 };          /* a is first copy of first_struct  */
			     /* initialized here                 */
  first_str *b = &a;         /* pointer to a first_struct        */
  int    u = b -> x;         /* here's how we dereference        */
  double v = b -> y;
  cout << "b -> x = " << u << ",  b -> y = " << v << "\n\n";
}
